## START: Set by rpmautospec
## (rpmautospec version 0.2.5)
%define autorelease(e:s:pb:) %{?-p:0.}%{lua:
    release_number = 2;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{?dist}
## END: Set by rpmautospec

%global commit c045058ed70f4a5944c77c88c4c4f01f35fe80c8
%global snapdate 20230910

Name:           lexertl14
Summary:        The Modular Lexical Analyser Generator
Version:        0.1.0^%{snapdate}git%(c='%{commit}'; echo "${c:0:7}")
Release:        %autorelease

License:        BSL-1.0
URL:            https://github.com/BenHanson/lexertl14
Source:         %{url}/archive/%{commit}/lexertl14-%{commit}.tar.gz

BuildRequires:  gcc-c++
BuildRequires:  cmake
BuildRequires:  dos2unix

# No compiled binaries are installed, so this would be empty.
%global debug_package %{nil}

%global common_description %{expand:
lexertl is a header-only library for writing lexical analysers. With lexertl
you can:

  • Build lexical analysers at runtime
  • Scan Unicode and ASCII input
  • Scan from files or memory
  • Generate C++ code or even write your own code generator}

%description %{common_description}


%package devel
Summary:        %{summary}

# Header-only library:
Provides:       lexertl14-static = %{version}-%{release}

%description devel %{common_description}


%package examples
Summary:        Examples for lexertl14
BuildArch:      noarch

%description examples
%{summary}.


%prep
%autosetup -n lexertl14-%{commit} -p1
# Fix line terminations (particularly for files that may be installed)
find . -type f -exec file '{}' '+' |
  grep -E '\bCRLF\b' |
  cut -d ':' -f 1 |
  xargs -r dos2unix --keepdate


%build
%cmake -DBUILD_TESTING:BOOL=on
%cmake_build


%install
%cmake_install


%check
%ctest


%files devel
%license include/lexertl/licence_1_0.txt
%doc README.md

%{_includedir}/lexertl/

%{_libdir}/cmake/lexertl/


%files examples
%license include/lexertl/licence_1_0.txt
%doc examples/*


%changelog
* Tue Sep 26 2023 Benjamin A. Beasley <code@musicinmybrain.net> 0.1.0^20230910gitc045058-2
- Keep timestamps when converting text file line endings

* Mon Sep 11 2023 Benjamin A. Beasley <code@musicinmybrain.net> 0.1.0^20230910gitc045058-1
- Update to c045058 (multilib fixed upstream)

* Fri Sep 08 2023 Benjamin A. Beasley <code@musicinmybrain.net> 0.1.0^20230904git86c90c3-4
- Use a proper patch to fix multilib paths, and offer it upstream

* Fri Sep 08 2023 Benjamin A. Beasley <code@musicinmybrain.net> 0.1.0^20230904git86c90c3-3
- Remove an obsolete commented-out sed-patch

* Tue Sep 05 2023 Benjamin A. Beasley <code@musicinmybrain.net> 0.1.0^20230904git86c90c3-2
- Improve the Summary

* Mon Sep 04 2023 Benjamin A. Beasley <code@musicinmybrain.net> 0.1.0^20230904git86c90c3-1
- Update to 86c90c3 (Restore the ability to run tests with BUILD_TESTING
  and ctest)

* Mon Sep 04 2023 Benjamin A. Beasley <code@musicinmybrain.net> 0.1.0^20230826git5bd3180-1
- Update to 5bd3180

* Mon Sep 04 2023 Benjamin A. Beasley <code@musicinmybrain.net> 0.1.0^20230610gitc4bcaf8-1
- Update to c4bcaf8

* Mon Sep 04 2023 Benjamin A. Beasley <code@musicinmybrain.net> 0.1.0^20230519git2e2893c-1
- Update to 2e2893c

* Thu Jul 20 2023 Fedora Release Engineering <releng@fedoraproject.org> 0.1.0^20230227gitaeddda8-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_39_Mass_Rebuild

* Thu May 25 2023 Benjamin A. Beasley <code@musicinmybrain.net> 0.1.0^20230227gitaeddda8-3
- Do not number the sole Source

* Thu May 25 2023 Benjamin A. Beasley <code@musicinmybrain.net> 0.1.0^20230227gitaeddda8-2
- Form the short commit hash with only shell builtins

* Fri Mar 10 2023 Benjamin A. Beasley <code@musicinmybrain.net> 0.1.0^20230227gitaeddda8-1
- Update to aeddda8 (Unicode 15.1.0 and other minor enhancements)

* Thu Jan 19 2023 Fedora Release Engineering <releng@fedoraproject.org> 0.1.0^20220919git8b8ead2-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_38_Mass_Rebuild

* Tue Dec 20 2022 Benjamin A. Beasley <code@musicinmybrain.net> 0.1.0^20220919git8b8ead2-2
- Indicate dirs. in files list with trailing slashes

* Tue Sep 20 2022 Benjamin A. Beasley <code@musicinmybrain.net> 0.1.0^20220919git8b8ead2-1
- Update to 8b8ead2 (Update to the latest Unicode standard)

* Fri Aug 05 2022 Benjamin A. Beasley <code@musicinmybrain.net> 0.1.0^20220228gitcd5a1f1-3
- Update License to SPDX

* Thu Jul 21 2022 Fedora Release Engineering <releng@fedoraproject.org> 0.1.0^20220228gitcd5a1f1-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_37_Mass_Rebuild

* Mon Feb 28 2022 Benjamin A. Beasley <code@musicinmybrain.net> 0.1.0^20220228gitcd5a1f1-1
- Drop “forge” macros; adapt to current snapshot versioning guidelines

* Mon Feb 28 2022 Benjamin A. Beasley <code@musicinmybrain.net> 0.1.0-6
- Update to cd5a1f1 (Unicode 15)

* Thu Jan 20 2022 Fedora Release Engineering <releng@fedoraproject.org> 0.1.0-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_36_Mass_Rebuild

* Wed Dec 22 2021 Benjamin A. Beasley <code@musicinmybrain.net> 0.1.0-4
- Update to 2ea71b8

* Tue Dec 14 2021 Benjamin A. Beasley <code@musicinmybrain.net> 0.1.0-3
- Dep. on cmake-filesystem is now auto-generated

* Fri Nov 19 2021 Benjamin A. Beasley <code@musicinmybrain.net> 0.1.0-2
- Update to commit 488602f

* Wed Aug 25 2021 Benjamin A. Beasley <code@musicinmybrain.net> 0.1.0-1
- Initial package
